#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <libavutil/sha.h>

#include "../util.h"

char *hashfile(char *path)
{
	struct AVSHA *ctx;
	int i, fd;
	char *ptr, *buf;
	size_t len, size;
	FILE *stream;
	if ((fd = open(path, O_RDONLY)) < 0)
		job_failed("Could not open file for hashing: %s", strerror(errno));
	if (!(ctx = av_sha_alloc()))
		exit(99);
	av_sha_init(ctx, 256);
	buf = xmalloc(4096);
	while ((len = read(fd, buf, 4096)) > 0)
		av_sha_update(ctx, buf, len);
	if (len < 0)
		job_failed("Could not read file for hashing: %s", strerror(errno));
	close(fd);
	av_sha_final(ctx, buf);
	av_free(ctx);
	if (!(stream = open_memstream(&ptr, &size)))
		exit(99);
	fprintf(stream, "sha256:");
	for (i = 0; i < 32; i ++)
		fprintf(stream, "%02hhx", buf[i]);
	free(buf);
	fclose(stream);
	return ptr;
}
